#####################################################################
#
# Steve's Survey Script
# Version 0.1b Beta
#
# See VERSION.TXT for version history.
#
#####################################################################
#
# Copyright (C) 2000  
# Steve Thomas
# 
# Contact Info:
#   Snail-Mail:
#     Steve Thomas
#     c/o IC Online Services
#     17252 Hawthorne Bl.
#     Suite 200
#     Torrance, CA 90504
#     USA
#   E-mail:
#     stevethomas@mailcity.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to:
# The Free Software Foundation, Inc.
# 59 Temple Place
# Suite 330
# Boston, MA  02111-1307
# USA.
#
# Steve's Scripts
# http://www.sthomas.net/perl/scripts/
#
# Thanks to the Perl community, for being so 'open'-minded, 
# Larry Wall, for creating Perl in the first place, and 
# EverySoft, for providing me with a first-rate program 
# (EveryAuction) to hack while I was self-teaching myself 
# the little bit I know about the language.
#
# Please don't remove the links to the script home page. You can
# if you really want to, but it'd be nice if you left them. Thx, ST
# 
#####################################################################
#####################################################################
#
#  Main Program
#
#  Don't change anything below this line unless you're
#  customizing the program!
#
#####################################################################

#-> Don't change or remark this line! 
require "./settings.pl";

#-> Get configuration information
&get_config;

#-> Print the 'content-type' statement and html header to the browser
print "Content-type: text/html\n\n" if ($contenttype);
print "<html>\n<head>\n<title>$title</title>\n</head>\n$body\n";
print "<center><img src=\"$logourl\" border=0></center>\n" if ($logourl ne '');

#-> Split argument
@arg=split(/&/,$ENV{'QUERY_STRING'});
$pass = $arg[0];
$action = $arg[1];

#-> Check password
&oops("Invalid password!") unless (lc($password) eq lc($pass));

print "<p align=center><b><big>Survey Administration</big></b></p><hr>\n";

#-> Perform various actions...

if ($action eq '') {
	print <<"EOF";
<p align=center><b>Close a survey</b></p>
<p align=center><table width="100%" border=0 cellspacing=0 cellpadding=2>
EOF
	if (!(-d "$safedir")) { mkdir "$safedir", 0777; }
	&oops("Could not open survey directory for read!") unless (opendir DIR, "$safedir");
	@allfiles = readdir DIR;
	closedir DIR;
	chomp(@allfiles);
	foreach $file (@allfiles) {
		if ((-T "$safedir/$file") && (!($file =~ /\.closed/i))) {
			&oops("Could not open survey file $file for read!") unless (open FILE, "$safedir/$file");
			@lines=<FILE>;
			close FILE;
			chomp(@lines);
			print "<tr><td align=left><a href=\"$ENV{'SCRIPT_NAME'}?$password&close&$file\">$file</a></td><td align=left>$lines[0]</td></tr>\n";
		}
	}
	print "</table><hr>\n";
}

elsif ($action eq 'close') {
	&oops("Survey is already closed!") if (-T "$safedir/$arg[2].closed");
	&oops("Invalid open survey!") unless (-T "$safedir/$arg[2]");
	&oops("Could not open survey file for read!") unless (open FILE, "$safedir/$arg[2]");
	@lines=<FILE>;
	close FILE;
	chomp(@lines);
	&oops("Could not open closed survey file for write!") unless (open FILE, ">$safedir/$arg[2].closed");
	foreach $line (@lines) { print FILE "$line\n"; }
	close FILE;
	&oops("Could not delete open survey file!") unless (unlink("$safedir/$arg[2]"));
	print "<p align=center>Survey \"<b>$arg[2]</b>\" <i>($lines[0])</i> has been closed.</p><hr>";
}




#-> Close HTML page and exit
print "\n</body>\n</html>\n";
exit;

