#####################################################################
#
# Steve's Survey Script
# Version 0.1b Beta
#
# See VERSION.TXT for version history.
#
#####################################################################
#
# Copyright (C) 2000  
# Steve Thomas
# 
# Contact Info:
#   Snail-Mail:
#     Steve Thomas
#     c/o IC Online Services
#     17252 Hawthorne Bl.
#     Suite 200
#     Torrance, CA 90504
#     USA
#   E-mail:
#     stevethomas@mailcity.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to:
# The Free Software Foundation, Inc.
# 59 Temple Place
# Suite 330
# Boston, MA  02111-1307
# USA.
#
# Steve's Scripts
# http://www.sthomas.net/perl/scripts/
#
# Thanks to the Perl community, for being so 'open'-minded, 
# Larry Wall, for creating Perl in the first place, and 
# EverySoft, for providing me with a first-rate program 
# (EveryAuction) to hack while I was self-teaching myself 
# the little bit I know about the language.
#
# Please don't remove the links to the script home page. You can
# if you really want to, but it'd be nice if you left them. Thx, ST
# 
#####################################################################
#####################################################################
#
#  Main Program
#
#  Don't change anything below this line unless you're
#  customizing the program!
#
#####################################################################

#-> Don't change this line!
require "./settings.pl"; 

#-> Get the configuration variables
&get_config;

#-> Print the 'content-type' statement and html header to the browser
print "Content-type: text/html\n\n" if ($contenttype);
print "<html>\n<head>\n<title>$title</title>\n</head>\n$body\n";
print "<center><img src=\"$logourl\" border=0></center>\n" if ($logourl ne '');

#-> Get data from posted form
&get_form_data;

#-> Remove bad words from comment
foreach $bw (keys %badwords) { $form{'comment'} =~ s/$bw/$badwords{$bw}/gi; }

#-> Error checking
&oops("You must make a selection!") unless (($form{'choice'} eq 'yes') || ($form{'choice'} eq 'no') || ($form{'choice'} eq 'und'));
&oops("Comment is too long!") unless (length($form{'comment'}) < 51);
&oops("That survey is closed!") if ($survey =~ /\.closed/i);  # make sure you can't alter a closed survey
if (!(-d "$safedir")) { &oops("Could not create survey directory!") unless (mkdir "$safedir", 0777); }

#-> Check for / create survey file
if ((!(-T "$safedir/$form{'survey'}")) && ($dynamic)) {
	&oops("There's no question field in the form!") if ($form{'question'} eq '');
	&oops("There's no survey name!") if ($form{'survey'} eq '');
	&oops("Could not create new survey file!") unless (open FILE, ">$safedir/$form{'survey'}");
	print FILE "$form{'question'}\n";
	print FILE "0,0,0\n";
	close FILE;
}
else { 	&oops("Invalid survey!") unless (-T "$safedir/$form{'survey'}"); }

#-> Read survey file
&oops("Could not open survey file for read!") unless (open FILE, "$safedir/$form{'survey'}");
($question, $stats, @answers) = <FILE>;
close FILE;
chomp($question, $stats, @answers);

#-> Check to see if a vote has come from the same IP before
if (!($dupipok)) {
	foreach $tmv (@answers) {
		@answe = split(/,/,$tmv);
		if ($answe[1] eq "$ENV{'REMOTE_HOST'}") {
			&oops("A vote from your IP address has already been received. Only one vote is allowed per IP address.");
}}}

#-> Check to see if a vote has come from the same IP within the last hour
if (($nohammer) && ($dupipok)) {
	foreach $tmv (@answers) {
		@answe = split(/,/,$tmv);
		if (($answe[1] eq "$ENV{'REMOTE_HOST'}") && ($answe[0] > (time - 3600))) {
			&oops("A vote from your IP address has been received within the last hour. Please try again later.");
}}}

#-> Get current results
($yesans, $noans, $undans) = split(/,/,$stats,3);

#-> Add current answer to results
$yesans++ if ($form{'choice'} eq 'yes');
$noans++ if ($form{'choice'} eq 'no');
$undans++ if ($form{'choice'} eq 'und');
$form{'comment'} =~ s/,//g;          # strip commas from comment
$form{'comment'} =~ s/\</\<!-- /g;   # comment out html code
$form{'comment'} =~ s/\>/ --\>/g;    #   "      "    "   "
$thetime=time;
$thisans="$thetime,$ENV{'REMOTE_HOST'},$form{'choice'},$form{'comment'}";
push(@answers,$thisans);

#-> Write numbers and answers back to survey file
&oops("Could not open survey file for writing!") unless (open FILE, ">$safedir/$form{'survey'}");
print FILE "$question\n$yesans,$noans,$undans\n";
foreach $answer (@answers) { print FILE "$answer\n"; }
close FILE;

#-> Prepare variables for display
$totalanswers=($yesans + $noans + $undans);
$yesanswers=$yesans;
$noanswers=$noans;
$undecidedanswers=$undans;
$yespercent=(($yesanswers / $totalanswers) * 100);
$nopercent=(($noanswers / $totalanswers) * 100);
$undecidedpercent=(($undecidedanswers / $totalanswers) * 100);

#-> Print results back to browser and exit
&disp_results;
print "\n</body>\n</html>\n";
exit;

#####################################################################
#
#  Subroutines
#
#####################################################################

#####################################################################
# Sub: Display Survey Results
# Displays the results of the survey
#####################################################################
#-> Use these variables for displaying stats - they all have
#   numeric values, and should be self-explanitory...
#
#   $totalanswers
#   $yesanswers
#   $noanswers
#   $undecidedanswers
#   $yespercent
#   $nopercent
#   $undecidedpercent
#
sub disp_results {  
	$frame="";
	$frame=" target=\"_top\"" if ($wholepage);
	print "<p align=center>Thank you for completing the survey!<br>Here's the results so far:</p><p align=center><font size=+1><b>$question</b></font></p><p align=center><b>Yes</b>: $yesanswers <i>(";
	printf("%.2f",$yespercent);
	print "\%)</i><br><b>No</b>: $noanswers <i>(";
	printf("%.2f",$nopercent);
	print "\%)</i><br><b>Undecided</b>: $undecidedanswers <i>(";
	printf("%.2f",$undecidedpercent);
	print <<"EOF";
\%)</i></p><p align=center>
<a href="$returnlink"$frame>$returntext</a><hr>
EOF
	while ($answ = pop(@answers)) {
		($thetime, $theip, $theanswer, $thecomment) = split(/,/,$answ,4);
		$thetime=localtime($thetime);
		$theanswer="Yes" if ($theanswer eq 'yes');
		$theanswer="No" if ($theanswer eq 'no');
		$theanswer="Undecided" if ($theanswer eq 'und');
		print "$thetime - <b>$theanswer</b>";
		print " - $thecomment" if ($thecomment ne '');
		print "<hr>\n";
	}
	print "<center><font size=-1><i>Steve's Survey Script<br>Available from <a href=\"http://www.sthomas.net/perl/scripts/\" target=\"_top\">Steve's Scripts</a></i></font></center><hr></p>";
}

