#####################################################################
#
# Steve's Survey Script
# Version 0.1b Beta
#
# See VERSION.TXT for version history.
#
#####################################################################
#
# Copyright (C) 2000  
# Steve Thomas
# 
# Contact Info:
#   Snail-Mail:
#     Steve Thomas
#     c/o IC Online Services
#     17252 Hawthorne Bl.
#     Suite 200
#     Torrance, CA 90504
#     USA
#   E-mail:
#     stevethomas@mailcity.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to:
# The Free Software Foundation, Inc.
# 59 Temple Place
# Suite 330
# Boston, MA  02111-1307
# USA.
#
# Steve's Scripts
# http://www.sthomas.net/perl/scripts/
#
# Thanks to the Perl community, for being so 'open'-minded, 
# Larry Wall, for creating Perl in the first place, and 
# EverySoft, for providing me with a first-rate program 
# (EveryAuction) to hack while I was self-teaching myself 
# the little bit I know about the language.
#
# Please don't remove the links to the script home page. You can
# if you really want to, but it'd be nice if you left them. Thx, ST
# 
#####################################################################
#####################################################################
#
#  Main Program
#
#  Don't change anything below this line unless you're
#  customizing the program!
#
#####################################################################

#-> Don't change or remark this line!
require "./settings.pl";

#-> Get configuration variables
&get_config;

#-> Print the 'content-type' statement and html header to the browser
print "Content-type: text/html\n\n" if ($contenttype);
print "<html>\n<head>\n<title>$title</title>\n</head>\n$body\n";
print "<center><img src=\"$logourl\" border=0></center>\n" if ($logourl ne '');

#-> Check for survey file
&oops("Survey does not exist, or is not closed!") unless (-T "$safedir/$ENV{'QUERY_STRING'}.closed");

#-> Read survey file
&oops("Could not open survey file for read!") unless (open FILE, "$safedir/$ENV{'QUERY_STRING'}.closed");
($question, $stats, @answers) = <FILE>;
close FILE;
chomp($question, $stats, @answers);

#-> Get current results
($yesans, $noans, $undans) = split(/,/,$stats,3);

#-> Prepare variables for display
$totalanswers=($yesans + $noans + $undans);
$yesanswers=$yesans;
$noanswers=$noans;
$undecidedanswers=$undans;
$yespercent=(($yesanswers / $totalanswers) * 100);
$nopercent=(($noanswers / $totalanswers) * 100);
$undecidedpercent=(($undecidedanswers / $totalanswers) * 100);

#-> Print results back to browser and exit
&disp_results;
print "\n</body>\n</html>\n";
exit;

#####################################################################
#
#  Subroutines
#
#####################################################################

#####################################################################
# Sub: Display Survey Results
# Displays the results of the survey
#####################################################################
#-> Use these variables for displaying stats - they all have
#   numeric values, and should be self-explanitory...
#
#   $totalanswers
#   $yesanswers
#   $noanswers
#   $undecidedanswers
#   $yespercent
#   $nopercent
#   $undecidedpercent
#
sub disp_results {  
	$frame="";
	$frame=" target=\"_top\"" if ($wholepage);
	print "<p align=center>Here's the results for survey \"$ENV{'QUERY_STRING'}\":<br><font size=-1><b><i>This survey is closed.</i></b></font></p><p align=center><font size=+1><b>$question</b></font></p><p align=center><b>Yes</b>: $yesanswers <i>(";
	printf("%.2f",$yespercent);
	print "\%)</i><br><b>No</b>: $noanswers <i>(";
	printf("%.2f",$nopercent);
	print "\%)</i><br><b>Undecided</b>: $undecidedanswers <i>(";
	printf("%.2f",$undecidedpercent);
	print <<"EOF";
\%)</i></p><p align=center>
<a href="$returnlink"$frame>$returntext</a><hr>
EOF
	while ($answ = pop(@answers)) {
		($thetime, $theip, $theanswer, $thecomment) = split(/,/,$answ,4);
		$thetime=localtime($thetime);
		$theanswer="Yes" if ($theanswer eq 'yes');
		$theanswer="No" if ($theanswer eq 'no');
		$theanswer="Undecided" if ($theanswer eq 'und');
		print "$thetime - <b>$theanswer</b>";
		print " - $thecomment" if ($thecomment ne '');
		print "<hr>\n";
	}
	print "<center><font size=-1><i>Steve's Survey Script<br>Available from <a href=\"http://www.sthomas.net/perl/scripts/\" target=\"_top\">Steve's Scripts</a></i></font></center><hr></p>";
}



